package com.ruoyi.system.service.impl.projectV2.common;

import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.entity.SysDept;
import com.ruoyi.common.core.domain.model.LoginUser;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.system.domain.projectV2.ZsyzSbbzb;
import com.ruoyi.system.domain.projectV2.ZsyzShyj;
import com.ruoyi.system.mapper.projectV2.ZsyzSbbzbMapper;
import com.ruoyi.system.mapper.projectV2.ZsyzShyjMapper;
import com.ruoyi.system.service.projectV2.common.IZsyzCommonService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import static com.ruoyi.common.constant.CommonConstants.*;

/**
 * 公共
 *
 * @Author: tjf
 * @Date: 2023/2/24 10:53
 * @Describe:
 */
@Service
public class ZsyzCommonServiceImpL implements IZsyzCommonService {
    @Autowired
    private ZsyzShyjMapper zsyzShyjMapper;

    @Autowired
    private ZsyzSbbzbMapper zsyzSbbzbMapper;

    //主要功能, 对线索进度进行控制
    @Override
    public AjaxResult xssh(ZsyzShyj zsyzShyj) {
        //获取审核结果
        String shjg = zsyzShyj.getShjg();
        //往审核意见表插入数据
        LoginUser loginUser = SecurityUtils.getLoginUser();
        SysDept dept = loginUser.getUser().getDept();
        zsyzShyj.setDeptId(dept.getDeptId());
        zsyzShyj.setShrxm(dept.getDeptName());
        //判断项目阶段
        String progress = zsyzShyj.getXmjd();
        zsyzShyj.setXmjd(xmjd(progress));
        zsyzShyjMapper.insertZsyzShyj(zsyzShyj);
        ZsyzSbbzb zsyzSbbzb = new ZsyzSbbzb();
        zsyzSbbzb.setId(zsyzShyj.getXmId());
        if (ONE.equals(shjg)) {
            //通过
            //审核通过需要进入下一阶段/要素部门审核通过,不进行进度前进
            //判断项目进度
            zsyzSbbzb.setProgress(changeProgress(progress));
            zsyzSbbzbMapper.updateZsyzSbbzbProgress(zsyzSbbzb);
        }else if (TWO.equals(shjg)){
            //驳回
            zsyzSbbzb.setProgress(changeProgressBack(progress));
            zsyzSbbzbMapper.updateZsyzSbbzbProgress(zsyzSbbzb);
        }
        return AjaxResult.success();
    }

    //更改项目进度前进
    public String changeProgress(String progress) {
        if (ONE.equals(progress)){
            progress = TWO;
        }else if (FOR.equals(progress)){
            progress = FIV;
        }else if (SIX.equals(progress)){
            progress = SEV;
        }else if (EIG.equals(progress)){
            progress = NIN;
        }else if (TEN.equals(progress)){
            progress = ELE;
        }//项目入归暂时保留
        return progress;
    }

    //更改项目进度后退
    public String changeProgressBack(String progress) {
        if (TWO.equals(progress)){
            progress = ONE;
        }else if (FOR.equals(progress)){
            progress = TWO;
        }else if (SIX.equals(progress)){
            progress = FIV;
        }else if (EIG.equals(progress)){
            progress = SEV;
        }else if (TEN.equals(progress)){
            progress = NIN;
        }//项目入归暂时保留
        return progress;
    }

        //根据项目进度判断项目阶段
    public String xmjd(String code) {
        if (ONE.equals(code) || TWO.equals(code) || THR.equals(code) || FOR.equals(code) || FIV.equals(code)) {
            return "线索阶段";
        } else if (SIX.equals(code) || SEV.equals(code)) {
            return "签约阶段";
        } else if (EIG.equals(code) || NIN.equals(code)) {
            return "开工阶段";
        } else if (TEN.equals(code) || ELE.equals(code)) {
            return "投产阶段";
        }
        return "入归阶段";
    }
}
